import React from 'react';
import { Container, Typography, Button } from '@material-ui/core';

const channelName = window.location.href.split("/")[4]
const adminToken = window.location.href.split("/")[5]
const dataURL = "/cachedeets/"+ channelName + "/" + adminToken
const forceURL = "/force/"+ channelName + "/" + adminToken

class CacheDeets extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      cacheData: [],
      loading: true
    };
    this.setCacheData = this.setCacheData.bind(this);
    this.setLoading = this.setLoading.bind(this);
  }

  setCacheData(data) {
    let newState = this.state
    newState.cacheData = data
    this.setState(newState)
  }

  setLoading(data) {
    let newState = this.state
    newState.loading = data
    this.setState(newState)
  }

  componentDidMount() {
    // We should only fetch once!
    if (this.state.loading) {
      let actualURL = dataURL
      if (window.location.href.split("/")[2] === "192.168.1.111:3000") {
        //Frontend dev mode only
        actualURL = "/sampleData/cache.json"
      }
      fetch(actualURL).then((res) => res.json().then((data)=>{
        this.setLoading(false)
        this.setCacheData(data)
      }));
    }
  }

  render() {
    const loading = this.state.loading
    const setLoading = this.setLoading
    const cacheData = this.state.cacheData

    function handleClick(e) {
      setLoading(true)
      fetch(forceURL).then((data)=>{
        setLoading(false)
        window.location.reload()
      })
      console.log('The link was clicked.');  
    }

    if (loading) {
      return <p>Sorry, still loading...</p>
    }
    
    let dd = cacheData

    return (
      <Container>
        <Typography variant="h5" component="h2" gutterBottom>
          Server has cached data from <b>{dd.SongCount} published</b> performances
        </Typography>
        <Typography component="p" gutterBottom>
          Cache data is from about {dd.AgeStr} - it automatically gets updated if it's older than an hour.  If you're convinced using Martyn's bandwidth to refresh the cache earlier than that is worth it, here's the button below :
        </Typography>
        <Button variant="contained" color="primary" onClick={handleClick}>Force refresh cache</Button>
      </Container>
    );
  }
}

export default CacheDeets;
